build-ants3.sh 6.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206
  1. #!/bin/bash
  2. # This is a script for build avalon controller image
  3. #
  4. # Copyright 2014-2015 Mikeqin <Fengling.Qin@gmail.com>
  5. # Copyright 2012-2015 Xiangfu <xiangfu@openmobilefree.com>
  6. #
  7. # OPENWRT_DIR is ${ROOT_DIR}/openwrt, build the image in it
  8. # Controller's image should include the following configurations:
  9. # ${AVA_MACHINE}_owrepo : OpenWrt repo, format: repo_url@repo_ver
  10. # feeds.${AVA_MACHINE}.conf : OpenWrt feeds, file locate in cgminer-openwrt-packages
  11. # ${AVA_TARGET_BOARD}_brdcfg : OpenWrt target and config, file locate in cgminer-openwrt-packages
  12. #
  13. # Learn bash: http://explainshell.com/
  14. set -e
  15. SCRIPT_VERSION=30092017
  16. # Support machine: avalon6, avalon4
  17. [ -z "${AVA_MACHINE}" ] && AVA_MACHINE=bitmain
  18. [ -z "${AVA_TARGET_BOARD}" ] && AVA_TARGET_BOARD=tl-mr3020-v1
  19. # OpenWrt repo
  20. bitmain_owrepo="http://gogserver.dnsalias.com:3000/wareck/openwrt_chaos_calmer.git@master"
  21. # OpenWrt feeds
  22. FEEDS_CONF=feeds.${AVA_MACHINE}.conf
  23. # Board config: target(get it in the OpenWrt bin), config
  24. tl_wr703n_v1_brdcfg=("ar71xx" "config.${AVA_MACHINE}.703n")
  25. tl_mr3020_v1_brdcfg=("ar71xx" "config.${AVA_MACHINE}.mr3020")
  26. which wget > /dev/null && DL_PROG=wget && DL_PARA="-nv -O"
  27. which curl > /dev/null && DL_PROG=curl && DL_PARA="-L -o"
  28. # According to http://wiki.openwrt.org/doc/howto/build
  29. unset SED
  30. unset GREP_OPTIONS
  31. [ "`id -u`" == "0" ] && echo "[ERROR]: Please use non-root user" && exit 1
  32. # Adjust CORE_NUM by yourself
  33. [ -z "${CORE_NUM}" ] && CORE_NUM="$(expr $(nproc) + 1)"
  34. DATE=`date +%Y%m%d`
  35. SCRIPT_FILE="$(readlink -f $0)"
  36. SCRIPT_DIR=`dirname ${SCRIPT_FILE}`
  37. ROOT_DIR=${SCRIPT_DIR}/avalon
  38. OPENWRT_DIR=${ROOT_DIR}/openwrt
  39. prepare_version() {
  40. cd ${OPENWRT_DIR}
  41. GIT_VERSION=`git ls-remote https://github.com/wareck/cgminer-gekko master | cut -f1 | cut -c1-7`
  42. LUCI_GIT_VERSION=`git --git-dir=./feeds/luci/.git rev-parse HEAD | cut -c1-7`
  43. OW_GIT_VERSION=`git --git-dir=./feeds/cgminer/.git rev-parse HEAD | cut -c1-7`
  44. cat > ./files/etc/avalon_version << EOL
  45. Firmware - $DATE
  46. luci: $LUCI_GIT_VERSION
  47. cgminer: $GIT_VERSION
  48. cgminer-packages: $OW_GIT_VERSION
  49. EOL
  50. }
  51. prepare_config() {
  52. cd ${OPENWRT_DIR}
  53. eval OPENWRT_CONFIG=\${"`echo ${AVA_TARGET_BOARD//-/_}`"_brdcfg[1]} && cp ./feeds/cgminer/cgminer/data/${OPENWRT_CONFIG} .config
  54. }
  55. prepare_feeds() {
  56. cd ${OPENWRT_DIR}
  57. $DL_PROG https://raw.githubusercontent.com/csa402/cgminer-openwrt-packages/master/cgminer/data/${FEEDS_CONF} $DL_PARA feeds.conf && \
  58. ./scripts/feeds update -a && \
  59. ./scripts/feeds install -a
  60. if [ ! -e files ]; then
  61. ln -s feeds/cgminer/cgminer/root-files files
  62. fi
  63. }
  64. prepare_source() {
  65. echo "Gen firmware for ${AVA_TARGET_BOARD}:${AVA_MACHINE}"
  66. echo "TARGET BOARD :${AVA_TARGET_BOARD}"
  67. echo "TARGET MACHINE :${AVA_MACHINE}"
  68. cd ${SCRIPT_DIR}
  69. [ ! -d avalon ] && mkdir -p avalon/bin
  70. cd avalon
  71. if [ ! -d openwrt ]; then
  72. eval OPENWRT_URL=\${${AVA_MACHINE}_owrepo}
  73. PROTOCOL="`echo ${OPENWRT_URL} | cut -d : -f 1`"
  74. case "${PROTOCOL}" in
  75. git)
  76. GITBRANCH="`echo ${OPENWRT_URL} | cut -d @ -f 2`"
  77. GITREPO="`echo ${OPENWRT_URL} | cut -d @ -f 1`"
  78. git clone -b ${GITBRANCH} ${GITREPO} openwrt
  79. ;;
  80. svn)
  81. SVNVER="`echo ${OPENWRT_URL} | cut -d @ -f 2`"
  82. SVNREPO="`echo ${OPENWRT_URL} | cut -d @ -f 1`"
  83. svn co ${SVNREPO}@${SVNVER} openwrt
  84. ;;
  85. http)
  86. GITBRANCH="`echo ${OPENWRT_URL} | cut -d @ -f 2`"
  87. GITREPO="`echo ${OPENWRT_URL} | cut -d @ -f 1`"
  88. git clone ${GITREPO} openwrt
  89. ;;
  90. *)
  91. echo "Protocol not supported"; exit 1;
  92. ;;
  93. esac
  94. fi
  95. sed -i -e "s/git:\/\/github.com/http:\/\/github.com/g" openwrt/package/network/services/odhcpd/Makefile
  96. [ ! -e dl ] && mkdir dl
  97. cd ${OPENWRT_DIR}
  98. ln -sf ../dl
  99. }
  100. build_image() {
  101. cd ${OPENWRT_DIR}
  102. yes "" | make oldconfig > /dev/null
  103. # clean before build
  104. make -j${CORE_NUM} clean world
  105. #make -j${CORE_NUM} world V=s
  106. }
  107. build_cgminer() {
  108. cd ${OPENWRT_DIR}
  109. rm -f ./dl/cgminer-*.tar.bz2
  110. yes "" | make oldconfig > /dev/null
  111. make -j${CORE_NUM} package/cgminer/{clean,compile}
  112. if [ "$?" == "0" ]; then
  113. eval AVA_TARGET_PLATFORM=\${"`echo ${AVA_TARGET_BOARD//-/_}`"_brdcfg[0]}
  114. cd ..
  115. mkdir -p ./bin/${AVA_TARGET_BOARD}
  116. cp ./openwrt/bin/${AVA_TARGET_PLATFORM}/packages/cgminer/cgminer*.ipk ./bin/${AVA_TARGET_BOARD}
  117. fi
  118. }
  119. do_release() {
  120. cd ${ROOT_DIR}
  121. eval AVA_TARGET_PLATFORM=\${"`echo ${AVA_TARGET_BOARD//-/_}`"_brdcfg[0]}
  122. mkdir -p ./bin/${DATE}/${AVA_TARGET_BOARD}/
  123. cp -a ./openwrt/bin/${AVA_TARGET_PLATFORM}/* ./bin/${DATE}/${AVA_TARGET_BOARD}/
  124. }
  125. cleanup() {
  126. cd ${ROOT_DIR}
  127. rm -rf openwrt/ > /dev/null
  128. }
  129. show_help() {
  130. echo "\
  131. Usage: $0 [--version] [--help] [--build] [--cgminer] [--cleanup]
  132. --version
  133. --help Display help message
  134. --build Get .config file and build firmware
  135. --cgminer Re-compile only cgminer openwrt package
  136. --test Dowload and prebuild files
  137. --cleanup Remove all files
  138. AVA_TARGET_BOARD Environment variable, available target:
  139. tl-wr703n-v1, pi-modelb-v1
  140. pi-modelb-v2, tl-mr3020-v1
  141. use pi-modelb-v2 if unset
  142. AVA_MACHINE Environment variable, available machine:
  143. avalon6, avalon4, gekko, rockminer
  144. use avalon6 if unset
  145. Written by: Xiangfu <xiangfu@openmobilefree.net>
  146. Fengling <Fengling.Qin@gmail.com>
  147. wareck <wareck@gmail.com>
  148. Version: ${SCRIPT_VERSION}"
  149. }
  150. if [ "$#" == "0" ]; then
  151. $0 --help
  152. exit 0
  153. fi
  154. for i in "$@"
  155. do
  156. case $i in
  157. --version|--help)
  158. show_help
  159. exit
  160. ;;
  161. --build)
  162. prepare_source && prepare_feeds && prepare_config && prepare_version && build_image && do_release
  163. ;;
  164. --cgminer)
  165. prepare_source && prepare_feeds && prepare_config && prepare_version && build_cgminer
  166. ;;
  167. --test)
  168. prepare_source && prepare_feeds && prepare_config && prepare_version
  169. ;;
  170. --cleanup)
  171. cleanup
  172. ;;
  173. *)
  174. show_help
  175. exit
  176. ;;
  177. esac
  178. done